#include "linkwilddog.h"
//#include "wifimang.h"

String mkresponse;
void init_get_wilddoghost() {
  RestClient mkclient = RestClient(mkhostname, mkhttpport);

  //mkclient.begin(ssid, ppsk);
  mkresponse = "";
  mkclient.setContentType("application/json");
  int statusCode = mkclient.get(mkresource, &mkresponse);
  DBG_OUTPUT_PORT.print("Status code from server: ");
  DBG_OUTPUT_PORT.println(statusCode);
  DBG_OUTPUT_PORT.print("Response body from server: ");
  DBG_OUTPUT_PORT.println(mkresponse);
  delay(1000);
  if (parseUserData(mkresponse.c_str())) {
    //DBG_OUTPUT_PORT.println(mkresponse.length());
    save_WDconfig();
//    printUserData();
  };//
  mkresponse="";
  //mkclient.stop();
}

bool parseUserData(const char* content) {        //, struct UserData * userData
  // Compute optimal size of the JSON buffer according to what we need to parse.
  // This is only required if you use StaticJsonBuffer.
  //const size_t BUFFER_SIZE =
  //  JSON_OBJECT_SIZE(3);     // the root object has 8 elements
  //  + JSON_OBJECT_SIZE(8);   // the "address" object has 5 elements
  //      + JSON_OBJECT_SIZE(2)   // the "geo" object has 2 elements
  //      + JSON_OBJECT_SIZE(3);  // the "company" object has 3 elements

  // Allocate a temporary memory pool on the stack
  //  const size_t BUFFER_SIZE =  JSON_OBJECT_SIZE(3);
  StaticJsonBuffer<WD_JSON_SIZE> jsonBuffer;
//  DBG_OUTPUT_PORT.println(JSON_OBJECT_SIZE(5));
  // If the memory pool is too big for the stack, use this instead:
  //DynamicJsonBuffer jsonBuffer;

  JsonObject& json = jsonBuffer.parseObject(content);

  if (!json.success()) {
    DBG_OUTPUT_PORT.println("JSON parsing failed!");
    return false;
  }
  // Here were copy the strings we're interested in
  strcpy(WDserver, json["server"]);
  WDport = json["port"];
  strcpy(WDfingerprint, json["fingerprint"]);
  // It's not mandatory to make a copy, you could just use the pointers
  // Since, they are pointing inside the "content" buffer, so you need to make
  // sure it's still in memory when you read the string
  json.printTo(DBG_OUTPUT_PORT);
  return true;
}

// Print the data extracted from the JSON
//void printUserData() {
//  DBG_OUTPUT_PORT.print("WDserver =  ");
//  DBG_OUTPUT_PORT.println(WDserver);
//  DBG_OUTPUT_PORT.print("WDport =  ");
//  DBG_OUTPUT_PORT.println(WDport);
//  DBG_OUTPUT_PORT.print("WDfingerprint = ");
//  DBG_OUTPUT_PORT.println(WDfingerprint);
//}

// Close the connection with the HTTP server
//void disconnecthost() {
//  DBG_OUTPUT_PORT.println("Disconnect");
//  client.stop();
//  //WiFi.disconnect();
//}

bool read_WDconfig() {
  File configFile = SPIFFS.open("/wilddog.json", "r");
  if (!configFile) {
    DBG_OUTPUT_PORT.println("Failed to open config file");
    return false;
  }
  DBG_OUTPUT_PORT.println("opened config file");
  size_t size = configFile.size();
  // Allocate a buffer to store contents of the file.
  std::unique_ptr<char[]> buf(new char[size]);

  configFile.readBytes(buf.get(), size);

  //  const size_t BUFFER_SIZE =  JSON_OBJECT_SIZE(3);
  StaticJsonBuffer<WD_JSON_SIZE> jsonBuffer;
  //  DynamicJsonBuffer jsonBuffer;
  JsonObject& json = jsonBuffer.parseObject(buf.get());

  if (json.success()) {
    DBG_OUTPUT_PORT.println("\nparsed json read form....");
    json.printTo(DBG_OUTPUT_PORT);
    strcpy(WDserver, json["server"]);
    WDport = json["port"];
    strcpy(WDfingerprint, json["fingerprint"]);
  } else {
    DBG_OUTPUT_PORT.println("failed to load json config");
    return false;
  }
  configFile.close();
  //end read
  return true;

}

bool save_WDconfig() {
  //save the custom parameters to FS
  DBG_OUTPUT_PORT.println("saving config");

  StaticJsonBuffer<WD_JSON_SIZE> jsonBuffer;
  //  DynamicJsonBuffer jsonBuffer;
  JsonObject& json = jsonBuffer.createObject();
  json["server"] = WDserver;
  json["port"] = WDport;
  json["fingerprint"] = WDfingerprint;

  File configFile = SPIFFS.open("/wilddog.json", "w");
  if (!configFile) {
    DBG_OUTPUT_PORT.println("failed to open config file for writing");
    return false;
  }
  json.printTo(DBG_OUTPUT_PORT);
  json.printTo(configFile);
  configFile.close();
  //end save
  return true;

}

