#include <Arduino.h>
#include <ESP8266WiFi.h>          //https://github.com/esp8266/Arduino
//#include <EEPROM.h>
//#include <DNSServer.h>
#include <ESP8266WebServer.h>

//#include <ESP8266WiFi.h>
//#include <WiFiClient.h>
//#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>
#include <Bounce2.h>

#include "wifimang.h"
#include "linkwilddog.h"
#include "WDrest.h"

extern "C" {
#include "gpio.h"
  //#include "user_interface.h"
}

#define DBG_OUTPUT_PORT Serial
#define BAUD_RATE  115200

#define motor_PWM 15//D1  ib
#define motor_Rotate 4//D3  ia

#define Door_closePin 5//D6
Bounce Bounce_Door_close = Bounce();

#define MT3271reciveDTMF 14//D8
#define MT3271clockPin 12//D5
#define MT3271dataPin 13//D7

#define BUILTIN_LED 16//D8

#define Door_open_close_time 500

#define Lock_pass_length 12
#define Lock_pass_num 4
int Lock_pass_bit = 8;//密码位数+1=9位

ADC_MODE(ADC_VCC);

char ssid[15];
char ppsk[20];
char mobile[15];//APP帐号数据
//char app_passwd[15];
//char passanswer[31];
char lockname[31] = "家里大门锁";

char WDserver[40] = "";     //WildDog 网站
int  WDport = 443;
char WDfingerprint[60] = "";

struct LockData {     //智能锁的数据和密码
  char id[10];
  char pass[Lock_pass_num][Lock_pass_length];
  int used = 0;
};
LockData lockdata;

unsigned int vcc;
unsigned int vbatt;

//byte mt;
unsigned long DTMFtime_first, DTMFtime_second;
volatile int FirstNUM = 0;
char DTMFpass[32];

//bool have_nopower = true ;

// ARDUINO entry point #1: runs once when you press reset or power the board
void setup() {
  DBG_OUTPUT_PORT.begin(BAUD_RATE);
  while (!DBG_OUTPUT_PORT) {
    ;  // wait for serial port to initialize
  }
  DBG_OUTPUT_PORT.print("BUILTIN_LED=="); DBG_OUTPUT_PORT.println(BUILTIN_LED);
  //set led pin as output
  pinMode(BUILTIN_LED, OUTPUT);
  pinMode(MT3271clockPin, OUTPUT);
  pinMode(MT3271dataPin, INPUT);
  //  pinMode(MT3271reciveDTMF, INPUT);
  pinMode(Door_closePin, INPUT_PULLUP);//door close
  Bounce_Door_close.attach(Door_closePin);
  Bounce_Door_close.interval(5); // interval in ms

  pinMode(motor_PWM, OUTPUT); pinMode(motor_Rotate, OUTPUT);
  digitalWrite(motor_PWM, LOW ); digitalWrite(motor_Rotate, LOW );
  //设置lockdata.id = ESP.getChipId();
  ultoa(ESP.getChipId(), lockdata.id, 10);//将无符号整型数value转换成字符串并返回该字符串,radix为转换时所用基数
  //Set_lock_password();
  randomSeed(ESP.getChipId());

  //=================
  if (!SPIFFS.begin()) {
    DBG_OUTPUT_PORT.println("Failed to mount file system");
    return ;
  }
  //SPIFFS.format();

  //=================
  if (!SPIFFS.exists("/wilddog.json")) { //重新设置所有&& digitalRead(Door_closePin) == LOW
    WiFiManager_setup();
  }
  //init_get_wilddoghost();
  read_WiFiconfig();
  read_WDconfig();

  //  EEPROM.begin(8);
  //  lockdata.used = EEPROM.read(0);
  setup_wifi();
  update_WDlock_passwd();
  lockdata.used = 0;
  WiFi.disconnect();
  //    EEPROM.write(0, lockdata.used);
  //    EEPROM.commit();
  wifi_station_disconnect();

  attachInterrupt(MT3271reciveDTMF, MT3271, RISING);
  DTMFtime_first = millis();
  vbatt = ESP.getVcc() * 0.96 * 0.95;
  //modem_sleep();

}

void setup_wifi() {
  boolean no_wifi = false;
  int Attempt = 0;
  wifi_station_connect();
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, ppsk);
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.print(".");
    Attempt++;
    if (Attempt  >= 10) {
      no_wifi = true;
      break;
    }
  }
  if (no_wifi) {

    DBG_OUTPUT_PORT.println("RECONFIG WIFI");
    ticker.attach(0.5, tick);
    String ressid = "RECONFIG" + String(ESP.getChipId());
    WiFiManager wifiManager;
    //    wifiManager.resetSettings();
    wifiManager.setDebugOutput(false);
    //wifiManager.setConnectTimeout(30);
    wifiManager.setTimeout(180);
    //    wifiManager.startConfigPortal(ressid.c_str());
    if (!wifiManager.autoConnect(ressid.c_str())) {
      DBG_OUTPUT_PORT.println("failed to connect and hit timeout");
      //reset and try again, or maybe put it to deep sleep
      detachInterrupt (MT3271reciveDTMF);
      light_sleep();
      light_sleep_wakeup();
      attachInterrupt(MT3271reciveDTMF, MT3271, RISING);
      delay(1000);
      ticker.detach();
      digitalWrite(BUILTIN_LED, LOW);
      return ;
      //      ESP.reset();

    }
    strcpy(ssid, WiFi.SSID().c_str());
    strcpy(ppsk, WiFi.psk().c_str());
    save_WiFiconfig();
    Serial.println("reconnected...yeey :)");
    //    ressid = "";
    ticker.detach();
  }
}

void light_sleep() {
  DBG_OUTPUT_PORT.println("going to light sleep / 0xFFFFFFF");
  delay(100);
  //wifi_station_disconnect();
  //wifi_set_opmode(NULL_MODE);
  wifi_fpm_set_sleep_type(LIGHT_SLEEP_T);
  wifi_fpm_open();
  gpio_pin_wakeup_enable(GPIO_ID_PIN(MT3271reciveDTMF), GPIO_PIN_INTR_HILEVEL);
  //  Bounce_Door_close.update(); if ( Bounce_Door_close.fell() && Bounce_Door_close.read() == LOW) {
  //    gpio_pin_wakeup_enable(GPIO_ID_PIN(Door_closePin), GPIO_PIN_INTR_LOLEVEL);
  //  }
  wifi_fpm_do_sleep(0xFFFFFFF);
  delay(200);

  /*wifi_fpm_open：开启强制休眠功能。
    wifi_fpm_close：关闭强制休眠功能。
    wifi_fpm_do_sleep：进入强制休眠。
    wifi_fpm_do_wakeup：从强制休眠中唤醒。
    wifi_fpm_set_sleep_type：设置强制休眠的休眠类型。
    wifi_fpm_get_sleep_type：查询强制休眠的休眠类型。
    typedef enum {
    GPIO_PIN_INTR_DISABLE = 0,//不使用中断
    GPIO_PIN_INTR_POSEDGE = 1,//上升沿
    GPIO_PIN_INTR_NEGEDGE = 2,//下降沿
    GPIO_PIN_INTR_ANYEDGE = 3,//双边沿
    GPIO_PIN_INTR_LOLEVEL = 4,//低电平
    GPIO_PIN_INTR_HILEVEL = 5//高电平
    } GPIO_INT_TYPE;*/
}

void light_sleep_wakeup() {
  gpio_pin_wakeup_disable();
  DBG_OUTPUT_PORT.println("wakeup from light sleep / 0xFFFFFFF");
  wifi_fpm_close();
  //wifi_set_opmode(STATION_MODE);
  //wifi_station_connect();
  //wifi_connect();
  delay(100);
}

//void modem_sleep() {
//  Serial.println("going to modem sleep ");
//  //  client.disconnect();
//  wifi_station_disconnect();
//  wifi_set_opmode(NULL_MODE);
//  wifi_set_sleep_type(MODEM_SLEEP_T);
//  wifi_fpm_open();
//  wifi_fpm_do_sleep(0xFFFFFFF);
//}
//void modem_wakeup() {
//  Serial.println("going to modem wakeup ");
//  wifi_fpm_do_wakeup();
//  wifi_fpm_close();
//  wifi_set_opmode(STATION_MODE);
//  wifi_station_connect();
//}

void MT3271()
{ //delay(3);
  uint8_t sound_number = 0;
  //digitalWrite(LED_BUILTIN, HIGH);
  DTMFtime_second = millis();
  //DBG_OUTPUT_PORT.println(DTMFtime_second - DTMFtime_first);
  if ((DTMFtime_second - DTMFtime_first) >= 4000) {
    FirstNUM = 0;
  }
  DTMFtime_first = DTMFtime_second;
  sound_number = shiftInn(MT3271dataPin, MT3271clockPin, LSBFIRST);
  if (sound_number > 10)
  {
    return;
  }
  if (sound_number == 10) {
    DTMFpass[FirstNUM] = '0';
  } else {
    DTMFpass[FirstNUM] = sound_number + '0';
  }
  //  DBG_OUTPUT_PORT.println(DTMFpass[FirstNUM]); //DBG_OUTPUT_PORT.println(DTMFpass[FirstNUM], BIN);
  FirstNUM++;
  DTMFpass[FirstNUM] = '\0';
  DBG_OUTPUT_PORT.println(DTMFpass);
  //  DBG_OUTPUT_PORT.print("comp=="); DBG_OUTPUT_PORT.println(strcmp(userData.pass[0], DTMFpass));
  //digitalWrite(LED_BUILTIN, LOW);
}

uint8_t shiftInn(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder)
{
  uint8_t value = 0;
  uint8_t i;

  for (i = 0; i < 4; ++i)
  {
    digitalWrite(clockPin, HIGH);
    if (bitOrder == LSBFIRST)
      value |= digitalRead(dataPin) << i;
    else
      value |= digitalRead(dataPin) << (7 - i);
    digitalWrite(clockPin, LOW);
  }
  return value;
}

boolean door_have_open = false;

int last_time = 0;
int no_work = 0;

void loop() {
  //  vcc = ESP.getVcc() * 0.96;  //DBG_OUTPUT_PORT.println(vcc);
  //  if (vcc - vbatt <= 0) {
  //    ticker.attach(1, tick);
  //  } else {
  //    ticker.detach();
  //  }
  //Bounce_Door_close.update();
  //  if ( Bounce_Door_close.update()) {
  //    int value = Bounce_Door_close.read();
  //    if ( value == LOW) {
  //      door_have_open = true;
  //      DBG_OUTPUT_PORT.println("close");
  //    } else {
  //      door_have_open = false;
  //      DBG_OUTPUT_PORT.println("open");
  //    }
  //  }

  yield();

  if (Lock_pass_num - lockdata.used < 1) {
    //modem_wakeup() ;
    setup_wifi();
    update_WDlock_passwd();
    lockdata.used = 0;
    WiFi.disconnect();
    //    EEPROM.write(0, lockdata.used);
    //    EEPROM.commit();
    //modem_sleep();
  }

  if (FirstNUM >= Lock_pass_bit) {
    for (int i = 0; i < Lock_pass_num; ++i) {
      if (strcmp(lockdata.pass[i], DTMFpass) == 0) {
        digitalWrite(BUILTIN_LED, HIGH);
        //delay(200);
        //        digitalWrite(motor_Rotate, LOW ); analogWrite(motor_PWM, 1023);
        digitalWrite(motor_Rotate, HIGH );
        delay(Door_open_close_time);
        digitalWrite(motor_Rotate, LOW);
        delay(500);
        digitalWrite(BUILTIN_LED, LOW);

        delay(6000);

        digitalWrite(BUILTIN_LED, HIGH);
        digitalWrite(motor_PWM, HIGH );
        delay(Door_open_close_time);
        digitalWrite(motor_PWM, LOW);

        FirstNUM = 0;
        lockdata.pass[i][0] = '\0';
        lockdata.used++;
        //        EEPROM.write(0, lockdata.used);
        //        EEPROM.commit();
        delay(500);
        digitalWrite(BUILTIN_LED, LOW);
        //        int open_time = 0;
        //        do {
        //          delay(1000);
        //          open_time ++;
        //          Bounce_Door_close.update();
        //        } while ((open_time <= 15) && (Bounce_Door_close.read() == LOW));//(Bounce_Door_close.read() == LOW)
        //door_have_open = true;
        no_work = 0;
      }
    }
  }
  yield();

  //  if ( Bounce_Door_close.fell() && Bounce_Door_close.read() == LOW) { //_close the door
  //    digitalWrite(BUILTIN_LED, HIGH);
  //    digitalWrite(motor_PWM, HIGH );
  //    delay(Door_open_close_time);
  //    digitalWrite(motor_PWM, LOW);
  //    delay(500);
  //    door_have_open = false;
  //    digitalWrite(BUILTIN_LED, LOW);
  //  }
  //  yield();
  //  if (Bounce_Door_close.read() == LOW) {
  no_work ++ ;
  delay(1000);
  //DBG_OUTPUT_PORT.println(no_work);
  //  }
  //  else {
  //    no_work = 0;
  //    last_time = FirstNUM;
  //  }
  if (no_work >= 30 ) {
    detachInterrupt (MT3271reciveDTMF);
    light_sleep();
    delay(200);
    light_sleep_wakeup();
    //modem_sleep();
    FirstNUM = 0;
    DTMFtime_first = millis();
    attachInterrupt(MT3271reciveDTMF, MT3271, RISING);
    no_work = 0;
  }
}
/*
  char   *ultoa(unsigned   long   value,char   *string,int   radix)
  将无符号整型数value转换成字符串并返回该字符串,radix为转换时所用基数
  char   *ltoa(long   value,char   *string,int   radix)
  将长整型数value转换成字符串并返回该字符串,radix为转换时所用基数
  char   *itoa(int   value,char   *string,int   radix)
  将整数value转换成字串存入string,radix为转换所用基数.
  double atof(char   *nptr)
  将字符串nptr转换成双精度数,并返回这个数,错误返回0
  int     atoi(char   *nptr)
  将字符串nptr转换成整型数,     并返回这个数,错误返回0
  long     atol(char   *nptr)
  将字符串nptr转换成长整型数,并返回这个数,错误返回0
  double  strtod(char   *str,char   **endptr)
  将字符串str转换成双精度数,并返回这个数,
  long  strtol(char   *str,char   **endptr,int   base)
  将字符串str转换成长整型数,   并返回这个数,
*/
