//第一次配置锁的设置，或者重设配置
#include "wifimang.h"
#include "linkwilddog.h"
#include "WDrest.h"

bool first_reg = false;
bool shouldSaveConfig = false;


void tick()
{
  //toggle state
  int state = digitalRead(BUILTIN_LED);  // get the current state of GPIO1 pin
  digitalWrite(BUILTIN_LED, !state);     // set pin to the opposite state
}

//gets called when WiFiManager enters configuration mode
void configModeCallback (WiFiManager *myWiFiManager) {
  DBG_OUTPUT_PORT.println("Entered config mode");
  DBG_OUTPUT_PORT.println(WiFi.softAPIP());
  //if you used auto generated SSID, print it
  DBG_OUTPUT_PORT.println(myWiFiManager->getConfigPortalSSID());
  //entered config mode, make led toggle faster
  ticker.attach(0.2, tick);
}

//callback notifying us of the need to save config
void saveConfigCallback () {
  DBG_OUTPUT_PORT.println("Should save config");
  shouldSaveConfig = true;
}

void WiFiManager_setup() {
  SPIFFS.format();
  // start ticker with 0.5 because we start in AP mode and try to connect
  ticker.attach(0.6, tick);

  //Local intialization. Once its business is done, there is no need to keep it around
  WiFiManager wifiManager;
  //reset settings - for testing
  //wifiManager.resetSettings();
  wifiManager.setDebugOutput(false);
  //wifiManager.setBreakAfterConfig(true);
  //  wifiManager.setConnectTimeout(120);
  wifiManager.setTimeout(600);
  wifiManager.setMinimumSignalQuality(20);

  //set callback that gets called when connecting to previous WiFi fails, and enters Access Point mode
  wifiManager.setAPCallback(configModeCallback);
  //set config save notify callback
  wifiManager.setSaveConfigCallback(saveConfigCallback);

  wifiManager.setCustomHeadElement("<meta charset=\"UTF-8\">");
  //fetches ssid and pass and tries to connect

  WiFiManagerParameter custom_text("<br/>智能锁管理手机号码，注册APP时请用此号码！") ; //  WiFiManagerParameter custom_text("<br/>你的APP管理帐号和密码");
  wifiManager.addParameter(&custom_text);
  WiFiManagerParameter custom_mobile("mobile", "手机号码", mobile, 15);
  wifiManager.addParameter(&custom_mobile);
//  WiFiManagerParameter custom_passwd("apppasswd", "管理密码", app_passwd, 15);
//  wifiManager.addParameter(&custom_passwd);

//  WiFiManagerParameter custom_text2("输入忘记密码问题答案（英文或数字）,用于取回管理密码");
//  wifiManager.addParameter(&custom_text2);
//  WiFiManagerParameter custom_passanswer("passanswer", "密码问题答案", passanswer, 31);
//  wifiManager.addParameter(&custom_passanswer);

  WiFiManagerParameter custom_text3("给你的锁起个名字(支持中文)");
  wifiManager.addParameter(&custom_text3);
  WiFiManagerParameter custom_lockname("lockname", "智能锁名称", lockname, 31);
  wifiManager.addParameter(&custom_lockname);
  //if it does not connect it starts an access point with the specified name
  //here  "AutoConnectAP"
  //and goes into a blocking loop awaiting configuration

  if (!wifiManager.autoConnect()) {
    DBG_OUTPUT_PORT.println("failed to connect and hit timeout");
    //reset and try again, or maybe put it to deep sleep
    light_sleep();
    ESP.reset();
    //    ESP.deepSleep(10 * 60 * 1000 * 1000);
    delay(1000);
  }
  first_reg = true;
  strcpy(mobile, custom_mobile.getValue());
//  strcpy(app_passwd, custom_passwd.getValue());
//  strcpy(passanswer, custom_passanswer.getValue());
  strcpy(lockname, custom_lockname.getValue());

  DBG_OUTPUT_PORT.println(mobile);
//  DBG_OUTPUT_PORT.println(app_passwd);
//  DBG_OUTPUT_PORT.println(passanswer);
  DBG_OUTPUT_PORT.println(lockname);
  //if you get here you have connected to the WiFi
  DBG_OUTPUT_PORT.println("connected...yeey :)");
  ticker.detach();
  //keep LED on
  digitalWrite(BUILTIN_LED, LOW);
  if (shouldSaveConfig) {
    strcpy(ssid, WiFi.SSID().c_str());
    strcpy(ppsk, WiFi.psk().c_str());
    save_WiFiconfig();
    init_get_wilddoghost();
    first_add_lock_and_owner();
  }
  WiFi.disconnect();
}

bool read_WiFiconfig() {
  File configFile = SPIFFS.open("/wifiapp.json", "r");
  if (!configFile) {
    DBG_OUTPUT_PORT.println("Failed to open config file");
    return false;
  }
  DBG_OUTPUT_PORT.println("opened config file");
  size_t size = configFile.size();
  // Allocate a buffer to store contents of the file.
  std::unique_ptr<char[]> buf(new char[size]);

  configFile.readBytes(buf.get(), size);
  //  const size_t BUFFER_SIZE =  JSON_OBJECT_SIZE(5);
  StaticJsonBuffer<MAN_JSON_SIZE> jsonBuffer;
  //  DynamicJsonBuffer jsonBuffer;
  JsonObject& json = jsonBuffer.parseObject(buf.get());

  if (json.success()) {
    DBG_OUTPUT_PORT.println("\nparsed json read form....");
    json.printTo(DBG_OUTPUT_PORT);
    strcpy(ssid, json["ssid"]);
    strcpy(ppsk, json["ppsk"]);
    strcpy(mobile, json["mobile"]);
//    strcpy(app_passwd, json["passwd"]);
//    strcpy(passanswer, json["passanswer"]);
    strcpy(lockname, json["lockname"]);
  } else {
    DBG_OUTPUT_PORT.println("failed to load json config");
    return false;
  }

  configFile.close();
  //end read
  return true;
}


bool save_WiFiconfig() {
  //save the custom parameters to FS
  DBG_OUTPUT_PORT.println("saving config");
  //  const size_t BUFFER_SIZE =  JSON_OBJECT_SIZE(5);
  StaticJsonBuffer<MAN_JSON_SIZE> jsonBuffer;
  //  DynamicJsonBuffer jsonBuffer;
  JsonObject& json = jsonBuffer.createObject();

  json["ssid"] = ssid;
  json["ppsk"] = ppsk;
  json["mobile"] = mobile;
//  json["passwd"] = app_passwd;
//  json["passanswer"] = passanswer;
  json["lockname"] = lockname;

  File configFile = SPIFFS.open("/wifiapp.json", "w");
  if (!configFile) {
    DBG_OUTPUT_PORT.println("failed to open config file for writing");
    return false;
  }
  json.printTo(DBG_OUTPUT_PORT);
  json.printTo(configFile);
  configFile.close();
  //end save
  return true;
}

